
#include "w_inc.h"
#define THIS_PROFILE_ID 1
OEM_sock *sock_tcp=NULL;
#define WPOC_SERVER_PORT 1314
OEM_sock *wpoc_get_tcp_sock(void){return sock_tcp;}
void wpoc_tcp_recv(char *name, unsigned char *msg, int msglen);
void wpoc_set_line_off(void){
	if(wpoc_app.poc_login){
		wpoc_app.poc_login=0;
		w_poc_cmd_que_notes();
	}
	sock_tcp=NULL;
	wpoc_app.poc_tcp=0;
}
void tcp_sock_recv(char event,char *name,unsigned char *msg, int msg_len,void *param){
	switch(event){
		case OEM_SYS_SOCK_EVENT_CONNECT_OK:
			wlog_warn("%s OEM_SYS_SOCK_EVENT_CONNECT_OK",name);
			break;
		case OEM_SYS_SOCK_EVENT_RECV_DATA:
			wlog_warn("%s OEM_SYS_SOCK_EVENT_RECV_DATA",name);
			wpoc_tcp_recv(name, msg, msg_len);
			break;
		case OEM_SYS_SOCK_EVENT_SHUT_IND:
			wlog_warn("%s OEM_SYS_SOCK_EVENT_SHUT_IND",name);
			wpoc_set_line_off();
			break;
		case OEM_SYS_SOCK_EVENT_ERROR_IND:
			wlog_warn("%s OEM_SYS_SOCK_EVENT_ERROR_IND",name);
			wpoc_set_line_off();
			break;
	}
}
int wpoc_init_task(void *param){
	int ret;
	unsigned int value;
	wlog_warn("init start");
	wlog_info("psn:%u,pass:%s,dns:%s", wpoc.psn, wpoc.pass, wpoc.dns);
	for(;;){
		OEM_sys_sleep_ms(1000);
		//check ppp status
		if(OEM_sys_ppp_ready()!=0){
			wlog_warn("ppp not ready!!!");
			continue;
		}
		//check tcp status
		if(wpoc_app.poc_tcp==0){
			//get hid
			if(OEM_sys_get_hid(wpoc.hardid, sizeof(wpoc.hardid))!=0){
				wlog_warn("get hid fail");
				continue;
			}
			wlog_info("get hardid:%s", wpoc.hardid);
			value=funs_random_get(1000, 5000);
			wlog_warn("try connect after %u ms", value);
			OEM_sys_sleep_ms(value);
			//try dns
			if(0!=OEM_sys_dns(wpoc.dns, wpoc_app.tcp_ip,sizeof(wpoc_app.tcp_ip))){
				wlog_warn("dns fail!!!");
				continue;
			}
			//try tcp now
			sock_tcp=OEM_sys_sock_connect(OEM_TUP_TCP, wpoc_app.tcp_ip, WPOC_SERVER_PORT,tcp_sock_recv,&ret,10,100,"poc_cmd", NULL);
			if(sock_tcp==NULL){
				wlog_warn("tcp connect fail:%d", ret);
				continue;
			}
			wpoc_app.poc_tcp=1;
			wpoc_app.poc_login=0;
			wpoc_app.poc_heartick=0xff-1;
			wpoc_app.poc_login_status=0;
			wpoc_app.poc_login_timeout_counter=0;
			wpoc_app.poc_ping_with_time=0;
			wlog_warn("tcp online!!!");
			continue;
		}
		//try login
		if(wpoc_app.poc_login==0){
			if(wpoc_app.poc_login_status==0){
				wpoc_app.poc_login_status=1;
				wpoc_app.poc_login_counter=0;
				w_poc_cmd_que_tx_login(&wpoc);
			}else{
				if(++wpoc_app.poc_login_counter>10){
					wlog_warn("login process cmd timeout!!!");
					wpoc_app.poc_login_counter=0;
					if(++wpoc_app.poc_login_timeout_counter>3){
						wpoc_app.poc_login_timeout_counter=0;
						wlog_warn("login process cmd timeout max time, shut!!!");
						OEM_sys_sock_close(sock_tcp);
						wpoc_app.poc_tcp=0;
					}else wpoc_app.poc_login_status=0;
				}
			}
			continue;
		}
		//try heartick
		if(++wpoc_app.poc_heartick<30) continue;
		wpoc_app.poc_heartick=0;
		w_poc_cmd_que_tx_ping(!wpoc_app.poc_ping_with_time);//first login, ping with date&time
		if(wpoc_app.poc_ping_with_time==0) wpoc_app.poc_ping_with_time=1;
	}
}

/*
wpoc_init:POC
:0 ɹ, ʧ
*/
int wpoc_init(OEM_SYS_LOG_FUN fun){
	OEM_sys_set_pcid(THIS_PROFILE_ID);
	if(OEM_sys_log_init(fun)!=0) return -1;
	int ret=OEM_sys_task_new(wpoc_init_task, 16, 100, "wpoc",NULL);
	wlog_info("inti OEM_sys_task_new %s <%d>", ret==0?"ok":"error", ret);
	if(ret!=0) return -1;
	ret=OEM_sys_task_new(wpoc_que_task, 16, 100, "wpoc_que",NULL);
	wlog_info("que OEM_sys_task_new %s <%d>", ret==0?"ok":"error", ret);
	return ret;
}

void wpoc_tcp_recv(char *name, unsigned char *msg, int msglen){
	w_unpacking_buf(msg, msglen);
}