
#ifndef __W_OEM_H_
#define __W_OEM_H_

#define W_OEM_WEAK __attribute__((weak))

#define OEM_SYS_SOCK_EVENT_CONNECT_OK 	0
#define OEM_SYS_SOCK_EVENT_RECV_DATA	1
#define OEM_SYS_SOCK_EVENT_SHUT_IND		2
#define OEM_SYS_SOCK_EVENT_ERROR_IND	3

typedef enum{
	OEM_TUP_TCP,
	OEM_TUP_UDP
}OEM_TUP_ENUM;

typedef void OEM_sock;
typedef void *OEM_que;
typedef int (*OEM_SYS_TASK_FUN)(void *param);
typedef void (*OEM_SYS_LOG_FUN)(char *msg);
typedef void (*OEM_SYS_SOCK_FUN)(char event,char *name,unsigned char *msg, int msg_len,void *param);

void *OEM_sys_malloc(unsigned int byteSize) W_OEM_WEAK;
void OEM_sys_free(void *data) W_OEM_WEAK;

void OEM_sys_set_pcid(int pcid) W_OEM_WEAK;
void OEM_sys_sleep_ms(int ms) W_OEM_WEAK;
int OEM_sys_get_hid(char *outmsg, int msglen) W_OEM_WEAK;

int OEM_sys_task_new(OEM_SYS_TASK_FUN fun, int task_stack_k, int priority, const char *taskName,void *param) W_OEM_WEAK;

int OEM_sys_log_init(OEM_SYS_LOG_FUN fun) W_OEM_WEAK;
void OEM_sys_log_print(const char *mark,const char *level,char * fmt, ...) W_OEM_WEAK;

int OEM_sys_ppp_ready(void) W_OEM_WEAK;
int OEM_sys_dns(char *dns, char *outIp, int outIpSize) W_OEM_WEAK;

OEM_sock *OEM_sys_sock_connect(OEM_TUP_ENUM tup, char *ip, unsigned short port,OEM_SYS_SOCK_FUN fun,int *ret,int task_stack_k,int priority,const char *taskName, void *usr_data) W_OEM_WEAK;
int OEM_sys_sock_close(OEM_sock *handle) W_OEM_WEAK;
int OEM_sys_sock_send_data(OEM_sock *handle, unsigned char *data, int datalen) W_OEM_WEAK;

unsigned int OEM_sys_get_tick(void) W_OEM_WEAK;

int OEM_sys_queue_new(OEM_que *handle,unsigned int msgsize, unsigned int msgnum) W_OEM_WEAK;
int OEM_sys_queue_wait(OEM_que handle, unsigned char *msgBuf, unsigned int msgBufSize) W_OEM_WEAK;
int OEM_sys_queue_send(OEM_que handle, unsigned char *msgBuf, unsigned int msgBufSize) W_OEM_WEAK;
int OEM_sys_queue_del(OEM_que handle) W_OEM_WEAK;
#endif
